using System;
using System.Collections.Generic;
using System.Text;

namespace ControlPoint.ControlAPI {
    public class Device : Item {
        protected DeviceController _controller;

        public Device() {
        }

        public Device(DeviceController controller, SettingsList settings) : base(settings) {
            this._controller = controller;
            this._controller.Devices.Add(this);
            this.Settings.SetSetting("controllerId", this._controller.ID);
        }

        public Device(DeviceController controller) : base() {
            this._controller = controller;
            this._controller.Devices.Add(this);
        }

        public Device(SettingsList settings) : base(settings) {
            
        }

        public DeviceController Controller {
            get {
                return _controller;
            }
        }

        public override SettingsList Settings {
            get {
                return base.Settings;
            }
        }
    }
}
